Index: trunk/src/lib/util/executor/executor.h
===================================================================
--- trunk/src/lib/util/executor/executor.h	(revision 7201)
+++ trunk/src/lib/util/executor/executor.h	(revision 7221)
@@ -16,8 +16,8 @@
 //! an enumerator for the definition of the Type.
 typedef enum {
-  Executor_Objective         = 0x00000001,
-  Executor_Static            = 0x00000002,
-
-  Executor_NoLoadString      = 0x00000010,
+  Executor_Objective         = 1,
+  Executor_Static            = 2,
+
+  Executor_NoLoadString      = 8,
 } Executor_Type;
 
@@ -48,5 +48,5 @@
 
     /** executes a Command @param object the object to apply this to @param parameters the parameters the command takes */
-    virtual void execute (BaseObject* object, const void* parameters = NULL) = 0;
+    virtual void execute (BaseObject* object, const std::string& parameters = "") = 0;
 
     /** @returns the Type of this Function (either static or objective) */
@@ -87,4 +87,6 @@
 #define   l_FLOAT_DEFGRAB(i)        this->defaultValue[i].getFloat()
 //! where to chek for default STRING values
+#define   l_STRING_DEFGRAB(i)       this->defaultValue[i].getString()
+//! where to chek for default CSTRING values
 #define   l_CSTRING_DEFGRAB(i)      this->defaultValue[i].getCString()
 
@@ -190,20 +192,20 @@
 #define ExecutorExecute1(t1) \
    else if (this->paramCount == 1 && this->defaultValue[0] == t1##_PARAM) \
-    EXECUTOREXECUTER(_1_##t1)(t1##_FUNC((const char*)parameters, t1##_DEFGRAB(0)))
+    EXECUTOREXECUTER(_1_##t1)(t1##_FUNC(sub[0], t1##_DEFGRAB(0)))
 
 //! execute-macro for functions with two parameters
 #define ExecutorExecute2(t1,t2) \
    else if (this->paramCount == 2 && this->defaultValue[0] == t1##_PARAM && this->defaultValue[1] == t2##_PARAM) \
-    EXECUTOREXECUTER(_2_##t1##_##t2)(t1##_FUNC(sub.getString(0), t1##_DEFGRAB(0)), t2##_FUNC(sub.getString(1), t2##_DEFGRAB(1)))
+    EXECUTOREXECUTER(_2_##t1##_##t2)(t1##_FUNC(sub[0], t1##_DEFGRAB(0)), t2##_FUNC(sub[1], t2##_DEFGRAB(1)))
 
 //! execute-macro for functions with three parameters
 #define ExecutorExecute3(t1,t2,t3) \
    else if (this->paramCount == 3 && this->defaultValue[0] == t1##_PARAM && this->defaultValue[1] == t2##_PARAM && this->defaultValue[2] == t3##_PARAM) \
-    EXECUTOREXECUTER(_3_##t1##_##t2##_##t3)(t1##_FUNC(sub.getString(0), t1##_DEFGRAB(0)), t2##_FUNC(sub.getString(1), t2##_DEFGRAB(1)), t3##_FUNC(sub.getString(2), t3##_DEFGRAB(2)))
+    EXECUTOREXECUTER(_3_##t1##_##t2##_##t3)(t1##_FUNC(sub[0], t1##_DEFGRAB(0)), t2##_FUNC(sub[1], t2##_DEFGRAB(1)), t3##_FUNC(sub[2], t3##_DEFGRAB(2)))
 
 //! execute-macro for functions with four parameters
 #define ExecutorExecute4(t1,t2,t3,t4) \
    else if (this->paramCount == 4 && this->defaultValue[0] == t1##_PARAM && this->defaultValue[1] == t2##_PARAM && this->defaultValue[2] == t3##_PARAM && this->defaultValue[3] == t4##_PARAM) \
-    EXECUTOREXECUTER(_4_##t1##_##t2##_##t3##_##t4)(t1##_FUNC(sub.getString(0), t1##_DEFGRAB(0)), t2##_FUNC(sub.getString(1), t2##_DEFGRAB(1)), t3##_FUNC(sub.getString(2), t3##_DEFGRAB(2)), t4##_FUNC(sub.getString(3), t4##_DEFGRAB(3))) \
+    EXECUTOREXECUTER(_4_##t1##_##t2##_##t3##_##t4)(t1##_FUNC(sub[0], t1##_DEFGRAB(0)), t2##_FUNC(sub[1], t2##_DEFGRAB(1)), t3##_FUNC(sub[2], t3##_DEFGRAB(2)), t4##_FUNC(sub[3], t4##_DEFGRAB(3))) \
 
 
@@ -211,5 +213,5 @@
 #define ExecutorExecute5(t1,t2,t3,t4,t5) \
    else if (this->paramCount == 5 && this->defaultValue[0] == t1##_PARAM && this->defaultValue[1] == t2##_PARAM && this->defaultValue[2] == t3##_PARAM && this->defaultValue[3] == t4##_PARAM && this->defaultValue[4] == t5##_PARAM) \
-    EXECUTOREXECUTER(_5_##t1##_##t2##_##t3##_##t4##_##t5)(t1##_FUNC(sub.getString(0), t1##_DEFGRAB(0)), t2##_FUNC(sub.getString(1), t2##_DEFGRAB(1)), t3##_FUNC(sub.getString(2), t3##_DEFGRAB(2)), t4##_FUNC(sub.getString(3), t4##_DEFGRAB(3)), t5##_FUNC(sub.getString(4), t5##_DEFGRAB(4)))
+    EXECUTOREXECUTER(_5_##t1##_##t2##_##t3##_##t4##_##t5)(t1##_FUNC(sub[0], t1##_DEFGRAB(0)), t2##_FUNC(sub[1], t2##_DEFGRAB(1)), t3##_FUNC(sub[2], t3##_DEFGRAB(2)), t4##_FUNC(sub[3], t4##_DEFGRAB(3)), t5##_FUNC(sub[4], t5##_DEFGRAB(4)))
 
 
@@ -240,12 +242,12 @@
 #define EXECUTORTYPE                   Executor_Objective
 //! keeps information about a Executor
-template<class T> class ExecutorObjective : public Executor
+template<class T> class EXECUTOR : public Executor
 {
   public:
-    ExecutorObjective() : Executor() { };
+    EXECUTOR() : Executor() { };
     // COPY constuctor (virtual version)
     virtual Executor* clone () const
     {
-      ExecutorObjective<T>* executor = new ExecutorObjective<T>();
+      EXECUTOR<T>* executor = new EXECUTOR<T>();
       this->cloning(executor);
       executor->fp = this->fp;
@@ -266,8 +268,8 @@
     } fp;
 
-    virtual void execute (BaseObject* object, const void* parameters = NULL)
+    virtual void execute (BaseObject* object, const std::string& parameters = "")
     {
-      SubString sub((const char*) parameters, " \n\t,", '\\');
-      printf("%s :: %s\n", this->getName(), (const char*) parameters);
+      SubString sub;
+      sub.split(parameters, " \n\t,", '\\');
 //! FUNCTOR_LIST is the List of Executive Functions
 #define FUNCTOR_LIST(x) ExecutorExecute ## x
@@ -305,9 +307,9 @@
 {
   public:
-    ExecutorStatic() : Executor() { };
+    EXECUTOR() : Executor() { };
     // COPY constuctor
     virtual Executor* clone () const
     {
-      ExecutorStatic<T>* executor = new ExecutorStatic<T>();
+      EXECUTOR<T>* executor = new EXECUTOR<T>();
       this->cloning(executor);
       executor->fp = this->fp;
@@ -329,7 +331,8 @@
 
 
-    virtual void execute (BaseObject* object, const void* parameters = NULL)
+    virtual void execute (BaseObject* object, const std::string& parameters = "")
     {
-  SubString sub((const char*)parameters, " \n\t,");
+      SubString sub;
+      sub.split(parameters, " \n\t,", '\\');
 //! FUNCTOR_LIST is the List of Executive Functions
 #define FUNCTOR_LIST(x) ExecutorExecute ## x
Index: trunk/src/lib/util/executor/executor_specials.h
===================================================================
--- trunk/src/lib/util/executor/executor_specials.h	(revision 7201)
+++ trunk/src/lib/util/executor/executor_specials.h	(revision 7221)
@@ -60,5 +60,5 @@
      * @param loadString ignored in this case
      */
-    virtual void execute(BaseObject* object, const void* parameters = NULL)
+    virtual void execute(BaseObject* object, const std::string& = "")
     {
       if (object != NULL && this->element != NULL)
Index: trunk/src/lib/util/executor/functor_list.h
===================================================================
--- trunk/src/lib/util/executor/functor_list.h	(revision 7201)
+++ trunk/src/lib/util/executor/functor_list.h	(revision 7221)
@@ -21,5 +21,5 @@
    l_SHORT:     short
    l_FLOAT:     float
-   l_CSTRING:    const char*
+   l_STRING:    const std::string&
    l_XML_ELEM:  TiXmlElement*
  */
@@ -74,14 +74,8 @@
 //#define l_VECTOR_DEFAULT   Vector(0,0,0)        //!< Default value for a VECTOR
 
-#define l_CSTRING_TYPE     const char*          //!< The type of a STRING
-#define l_CSTRING_FUNC     isString             //!< The function to parse a STRING
-#define l_CSTRING_NAME     "string"             //!< The name of a STRING
-#define l_CSTRING_PARAM    MT_STRING            //!< the type of the parameter STRING
-#define l_CSTRING_DEFAULT  ""                   //!< a default Value for an STRING
-
 #define l_STRING_TYPE      const std::string&   //!< The type of a STRING
 #define l_STRING_FUNC      isString             //!< The function to parse a STRING
 #define l_STRING_NAME      "string"             //!< The name of a STRING
-#define l_STRING_PARAM     MT_STRING            //!< the type of the parameter STRING
+#define l_STRING_PARAM     MT_STRING           //!< the type of the parameter STRING
 #define l_STRING_DEFAULT   ""                   //!< a default Value for an STRING
 
@@ -99,11 +93,12 @@
   FUNCTOR_LIST(0)();
   //! makes functions with one string
-  FUNCTOR_LIST(1)(l_CSTRING);
+  FUNCTOR_LIST(1)(l_STRING);
   //! makes functions with two strings
-  FUNCTOR_LIST(2)(l_CSTRING, l_CSTRING);
+  FUNCTOR_LIST(2)(l_STRING, l_STRING);
   //! makes functions with three strings
-  FUNCTOR_LIST(3)(l_CSTRING, l_CSTRING, l_CSTRING);
+  FUNCTOR_LIST(3)(l_STRING, l_STRING, l_STRING);
   //! makes functions with four strings
-  FUNCTOR_LIST(4)(l_CSTRING, l_CSTRING, l_CSTRING, l_CSTRING);
+  FUNCTOR_LIST(4)(l_STRING, l_STRING, l_STRING, l_STRING);
+
 
   //! makes functions with one bool
@@ -141,9 +136,9 @@
 
   //! mixed values:
-  FUNCTOR_LIST(2)(l_CSTRING, l_FLOAT);
+  FUNCTOR_LIST(2)(l_STRING, l_FLOAT);
   FUNCTOR_LIST(2)(l_UINT, l_LONG);
-  FUNCTOR_LIST(2)(l_CSTRING, l_UINT);
+  FUNCTOR_LIST(2)(l_STRING, l_UINT);
 
-  FUNCTOR_LIST(3)(l_CSTRING, l_FLOAT, l_UINT);
+  FUNCTOR_LIST(3)(l_STRING, l_FLOAT, l_UINT);
 
 
Index: trunk/src/lib/util/helper_functions.cc
===================================================================
--- trunk/src/lib/util/helper_functions.cc	(revision 7201)
+++ trunk/src/lib/util/helper_functions.cc	(revision 7221)
@@ -22,38 +22,37 @@
 
 /**
- * checks if the input was a bool
+ * @brief checks if the input was a bool
  * @param BOOL a String that holds a bool: must be one of those: 1,0,true,false(case-insensitive)
  * @param defaultValue a default value that is set, if BOOL is corrupt
  * @return returns the bool, if BOOL was correct otherwise defaultValue
  */
-bool isBool(const char* BOOL, bool defaultValue)
+bool isBool(const std::string& BOOL, bool defaultValue)
 {
-  if (BOOL == NULL)
+  if (BOOL.empty())
     return defaultValue;
-  if(!strcmp(BOOL, "1") || !strcasecmp( BOOL, "true") )
+  if(BOOL[0] == '1' || BOOL == "true" )
     return true;
-  else if (!strcmp(BOOL, "0") || !strcasecmp( BOOL, "false"))
+  else if (BOOL[0] == '0' || BOOL == "false")
     return false;
   else
     return defaultValue;
-
 }
 
 
 /**
- * checks if the input was a int
+ * @brief checks if the input was a int
  * @param INT a String that holds an int.
  * @param defaultValue a default value that is set, if INT is corrupt
  * @return returns the contained int, if INT was correct otherwise defaultValue
  */
-int isInt(const char* INT, int defaultValue)
+int isInt(const std::string& INT, int defaultValue)
 {
-  if (INT == NULL)
+  if (INT.empty())
     return defaultValue;
   char* endPtr = NULL;
 
-  int result = strtol(INT, &endPtr, 10);
+  int result = strtol(INT.c_str(), &endPtr, 10);
 
-  if ( endPtr >= INT && endPtr < INT + strlen(INT))
+  if ( endPtr >= INT.c_str() && endPtr < INT.c_str()+ INT.size())
     return defaultValue;
   else
@@ -63,17 +62,17 @@
 
 /**
- * checks if the input was a float
+ * @brief checks if the input was a float
  * @param FLOAT a String that holds an float.
  * @param defaultValue a default value that is set, if FLOAT is corrupt
  * @return returns the contained float, if FLOAT was correct otherwise defaultValue
  */
-float isFloat(const char* FLOAT, float defaultValue)
+float isFloat(const std::string& FLOAT, float defaultValue)
 {
-  if (FLOAT == NULL)
+  if (FLOAT.empty())
     return defaultValue;
   char* endPtr = NULL;
-  double result = strtod(FLOAT, &endPtr);
+  double result = strtod(FLOAT.c_str(), &endPtr);
 
-  if ( endPtr >= FLOAT && endPtr < FLOAT + strlen(FLOAT))
+  if ( endPtr >= FLOAT.c_str() && endPtr < FLOAT.c_str() + FLOAT.size())
     return defaultValue;
   else
@@ -83,14 +82,57 @@
 
 /**
- * checks if the input was a string
+ * @brief checks if the input was a string
  * @param STING a String(char-array) that holds an string.
  * @param defaultValue a default value that is set, if STRING is corrupt
  * @return returns the contained string (char-array), if STRING was correct otherwise defaultValue
  */
-const char* isString(const char* STRING, const char* defaultValue)
+const char* isCString(const std::string& STRING, const char* defaultValue)
 {
-  if (STRING != NULL && strlen(STRING) > 0)
+  if (STRING.size() > 0)
+    return STRING.c_str();
+  else
+    return defaultValue;
+}
+
+/**
+ * @brief checks if the input was a string
+ * @param STING a String(char-array) that holds an string.
+ * @param defaultValue a default value that is set, if STRING is corrupt
+ * @return returns the contained string (char-array), if STRING was correct otherwise defaultValue
+ */
+std::string isString(const std::string& STRING, const std::string& defaultValue)
+{
+  if (STRING.size() > 0)
     return STRING;
   else
     return defaultValue;
 }
+
+
+/**
+ * @brief compares two strings without ignoring the case
+ * @param s1 first string
+ * @param s2 second string
+ */
+int nocase_cmp(const std::string& s1, const std::string& s2)
+{
+  std::string::const_iterator it1=s1.begin();
+  std::string::const_iterator it2=s2.begin();
+
+  //stop when either string's end has been reached
+  while ( (it1!=s1.end()) && (it2!=s2.end()) )
+  {
+    if(::toupper(*it1) != ::toupper(*it2)) //letters differ?
+     // return -1 to indicate smaller than, 1 otherwise
+      return (::toupper(*it1)  < ::toupper(*it2)) ? -1 : 1;
+    //proceed to the next character in each string
+    ++it1;
+    ++it2;
+  }
+  size_t size1=s1.size(), size2=s2.size();// cache lengths
+   //return -1,0 or 1 according to strings' lengths
+  if (size1==size2)
+    return 0;
+  return (size1<size2) ? -1 : 1;
+}
+
Index: trunk/src/lib/util/helper_functions.h
===================================================================
--- trunk/src/lib/util/helper_functions.h	(revision 7201)
+++ trunk/src/lib/util/helper_functions.h	(revision 7221)
@@ -7,4 +7,6 @@
 #define _HELPER_FUNCTIONS_H
 
+#include <string>
+
 // FORWARD DECLARATION
 
@@ -12,8 +14,13 @@
 *** HELPER FUNCTIONS ***
 ***********************/
-bool          isBool(const char* BOOL, bool defaultValue);
-int           isInt(const char* INT, int defaultValue);
-float         isFloat(const char* FLOAT, float defaultValue);
-const char*   isString(const char* STRING, const char* defaultValue);
+bool          isBool(const std::string& BOOL, bool defaultValue);
+int           isInt(const std::string& INT, int defaultValue);
+float         isFloat(const std::string& FLOAT, float defaultValue);
+const char*   isCString(const std::string& STRING, const char* defaultValue);
+std::string   isString(const std::string& STRING, const std::string& defaultValue);
+
+
+int           nocase_cmp(const std::string& s1, const std::string& s2);
+
 
 #endif /* _HELPER_FUNCTIONS_H */
Index: trunk/src/lib/util/loading/factory.cc
===================================================================
--- trunk/src/lib/util/loading/factory.cc	(revision 7201)
+++ trunk/src/lib/util/loading/factory.cc	(revision 7221)
@@ -23,22 +23,14 @@
 //SHELL_COMMAND(create, Factory, fabricate);
 
-
-/*  --------------------------------------------------
- *               Factory
- *   --------------------------------------------------
+/**
+ * @brief constructor
+ *
+ * set everything to zero and define factoryName
  */
-
-/**
- *  constructor
-
-   set everything to zero and define factoryName
-*/
-Factory::Factory (const char* factoryName, ClassID classID)
+Factory::Factory (const std::string& factoryName, ClassID classID)
+  : className(factoryName), classID(classID)
 {
   this->setClassID(CL_FACTORY, "Factory");
   this->setName(factoryName);
-
-  this->classID = classID;
-  this->className = factoryName;
 
   if( Factory::factoryList == NULL)
@@ -48,11 +40,9 @@
 }
 
-/** a reference to the First Factory */
+/** @brief a reference to the First Factory */
 std::list<Factory*>* Factory::factoryList = NULL;
 
 /**
- *  destructor
- *
- * clear the Q
+ * @brief destructor
  */
 Factory::~Factory ()
@@ -64,5 +54,5 @@
 
 /**
- * deletes all the Factories. (cleanup)
+ * @brief deletes all the Factories. (cleanup)
  */
 void Factory::deleteFactories()
@@ -90,5 +80,5 @@
 
 /**
- * Compares the Factories Name against a given ClassName
+ * @brief Compares the Factories Name against a given ClassName
  * @param className the Name of the Class to Query
  * @returns true on match, false otherwise.
@@ -96,10 +86,20 @@
 bool Factory::operator==(const char* className) const
 {
-  return(className != NULL && !strcmp(className, this->className));
+  return(className != NULL && this->className == className);
+}
+
+/**
+ * @brief Compares the Factories Name against a given ClassName
+ * @param className the Name of the Class to Query
+ * @returns true on match, false otherwise.
+ */
+bool Factory::operator==(const std::string& className) const
+{
+  return(this->className == className);
 }
 
 
 /**
- * Creates a new Object of type root->Value() (name)
+ * @brief Creates a new Object of type root->Value() (name)
  * @param root the XML-Root to match for the newly created Object
  * @returns a new Object of Type root->Value() on match, NULL otherwise
@@ -133,7 +133,7 @@
  * @returns a new Object of Type className on match, NULL otherwise
  */
- BaseObject* Factory::fabricate(const char* className)
+ BaseObject* Factory::fabricate(const std::string& className)
 {
-  if (className == NULL || Factory::factoryList == NULL)
+  if (Factory::factoryList == NULL)
     return NULL;
 
@@ -178,5 +178,5 @@
   else
   {
-    PRINTF(2)("Could not Fabricate an Object of ClassID '%h'\n", classID);
+    PRINTF(2)("Could not Fabricate an Object of ClassID '0x%h'\n", classID);
     return NULL;
   }
Index: trunk/src/lib/util/loading/factory.h
===================================================================
--- trunk/src/lib/util/loading/factory.h	(revision 7201)
+++ trunk/src/lib/util/loading/factory.h	(revision 7221)
@@ -27,5 +27,4 @@
 #include "parser/tinyxml/tinyxml.h"
 #include "base_object.h"
-#include "debug.h"
 #include <vector>
 #include <list>
@@ -34,5 +33,5 @@
  * Creates a factory to a Loadable Class.
  * this should be used at the beginning of all the Classes that should be loadable (in the cc-file)
-*/
+ */
 #define CREATE_FACTORY(CLASS_NAME, CLASS_ID) \
     tFactory<CLASS_NAME>* global_##CLASS_NAME##_Factory = new tFactory<CLASS_NAME>(#CLASS_NAME, CLASS_ID)
@@ -49,5 +48,5 @@
   static void deleteFactories();
 
-  static  BaseObject* fabricate(const char* className);
+  static  BaseObject* fabricate(const std::string& className);
   static  BaseObject* fabricate(ClassID classID);
   static  BaseObject* fabricate(const TiXmlElement* root = NULL);
@@ -56,17 +55,18 @@
   bool operator==(ClassID classID) const;
   bool operator==(const char* className) const;
+  bool operator==(const std::string& className) const;
 
   protected:
-    Factory (const char* factoryName, ClassID classID);
+    Factory (const std::string& factoryName, ClassID classID);
     virtual BaseObject* fabricateObject(const TiXmlElement* root = NULL) const = 0;
 
   protected:
-    ClassID                       classID;              //!< The Class-Identifyer of the Factory.
-    const char*                   className;            //!< The name of the Class.
+    const ClassID                 classID;              //!< The Class-Identifyer of the Factory.
+    const std::string             className;            //!< The name of the Class.
     static std::list<Factory*>*   factoryList;          //!< List of Registered Factories
 };
 
 /**
- *  a factory that is able to load any kind of Object
+ *  @brief a factory that is able to load any kind of Object
  * (this is a Functor)
  */
@@ -75,5 +75,5 @@
  public:
  /**
-  * creates a new type Factory to enable the loading of T
+  * @brief creates a new type Factory to enable the loading of T
   * @param factoryName the Name of the Factory to load.
   * @param classID the ID of the Class to be created.
@@ -85,5 +85,5 @@
   private:
    /**
-    * fabricates an Object of type T, with the constructor T::T(const TiXmlElemnt*)
+    * @brief fabricates an Object of type T, with the constructor T::T(const TiXmlElemnt*)
     * @param root the TiXmlElement T should load parameters from.
     * @return the newly fabricated T.
Index: trunk/src/lib/util/loading/game_loader.cc
===================================================================
--- trunk/src/lib/util/loading/game_loader.cc	(revision 7201)
+++ trunk/src/lib/util/loading/game_loader.cc	(revision 7221)
@@ -86,12 +86,11 @@
  * this will interprete the map/campaign files and recursivly load a tree of worlds/campaigns
  */
-ErrorMessage GameLoader::loadCampaign(const char* fileName)
+ErrorMessage GameLoader::loadCampaign(const std::string& fileName)
 {
   ErrorMessage errorCode;
-  char* campaignName = ResourceManager::getFullName(fileName);
-  if (campaignName)
+  std::string campaignName = ResourceManager::getFullName(fileName);
+  if (!campaignName.empty())
     {
       this->currentCampaign = this->fileToCampaign(campaignName);
-      delete[] campaignName;
     }
 }
@@ -105,12 +104,11 @@
  * this will interprete the map/campaign files and recursivly load a tree of worlds/campaigns
  */
-ErrorMessage GameLoader::loadNetworkCampaign(const char* fileName)
+ErrorMessage GameLoader::loadNetworkCampaign(const std::string& fileName)
 {
   ErrorMessage errorCode;
-  char* campaignName = ResourceManager::getFullName(fileName);
-  if (campaignName)
+  std::string campaignName = ResourceManager::getFullName(fileName);
+  if (!campaignName.empty())
   {
     this->currentCampaign = this->fileToCampaign(campaignName);
-    delete[] campaignName;
   }
 }
@@ -220,5 +218,5 @@
  * this will interprete the map/campaign files and recursivly load a tree of worlds/campaigns
  */
-Campaign* GameLoader::fileToCampaign(const char* fileName)
+Campaign* GameLoader::fileToCampaign(const std::string& fileName)
 {
   /* do not entirely load the campaign. just the current world
@@ -227,5 +225,5 @@
   */
 
-  if( fileName == NULL)
+  if( fileName.empty())
     {
       PRINTF(2)("No filename specified for loading");
@@ -233,16 +231,15 @@
     }
 
-  TiXmlDocument* XMLDoc = new TiXmlDocument( fileName);
+  TiXmlDocument XMLDoc(fileName);
   // load the campaign document
-  if( !XMLDoc->LoadFile())
+  if( !XMLDoc.LoadFile(fileName))
     {
       // report an error
-      PRINTF(1)("Could not load XML File %s: %s @ %d:%d\n", fileName, XMLDoc->ErrorDesc(), XMLDoc->ErrorRow(), XMLDoc->ErrorCol());
-      delete XMLDoc;
+      PRINTF(1)("Could not load XML File %s: %s @ %d:%d\n", fileName.c_str(), XMLDoc.ErrorDesc(), XMLDoc.ErrorRow(), XMLDoc.ErrorCol());
       return NULL;
     }
 
   // check basic validity
-  TiXmlElement* root = XMLDoc->RootElement();
+  TiXmlElement* root = XMLDoc.RootElement();
   assert( root != NULL);
 
@@ -251,15 +248,9 @@
       // report an error
       PRINTF(2)("Specified XML File is not an orxonox campaign file (Campaign element missing)\n");
-      delete XMLDoc;
       return NULL;
     }
 
   // construct campaign
-  Campaign* c = new Campaign( root);
-
-  // free the XML data
-  delete XMLDoc;
-
-  return c;
+  return new Campaign( root);
 }
 
Index: trunk/src/lib/util/loading/game_loader.h
===================================================================
--- trunk/src/lib/util/loading/game_loader.h	(revision 7201)
+++ trunk/src/lib/util/loading/game_loader.h	(revision 7221)
@@ -44,7 +44,7 @@
   static GameLoader* getInstance() { if(singletonRef == NULL) singletonRef = new GameLoader(); return singletonRef; }
 
-  ErrorMessage loadCampaign(const char* name);
+  ErrorMessage loadCampaign(const std::string& name);
   ErrorMessage loadDebugCampaign(Uint32 campaignID);
-  ErrorMessage loadNetworkCampaign(const char* fileName);
+  ErrorMessage loadNetworkCampaign(const std::string& fileName);
 
   ErrorMessage init();
@@ -62,5 +62,5 @@
   GameLoader ();
 
-  Campaign* fileToCampaign(const char* name);
+  Campaign* fileToCampaign(const std::string& name);
 
 
Index: trunk/src/lib/util/loading/load_param.cc
===================================================================
--- trunk/src/lib/util/loading/load_param.cc	(revision 7201)
+++ trunk/src/lib/util/loading/load_param.cc	(revision 7221)
@@ -28,7 +28,7 @@
  * @param executor the Executor, that executes the loading procedure.
  */
-CLoadParam::CLoadParam(const TiXmlElement* root, const char* paramName, BaseObject* object, const Executor& executor, bool inLoadCycle)
-{
-  this->paramName = paramName;
+CLoadParam::CLoadParam(const TiXmlElement* root, const std::string& paramName, BaseObject* object, const Executor& executor, bool inLoadCycle)
+  :  paramName(paramName), object(object)
+{
   this->object = object;
   this->inLoadCycle = inLoadCycle;
@@ -37,6 +37,5 @@
   if (likely(!inLoadCycle))
     this->loadElem = grabParameterElement(root, paramName);
-  //this->loadString = grabParameter(root, paramName);
-  else if (!strcmp(root->Value(), paramName))
+  else if (paramName == root->Value())
     this->loadElem = (TiXmlElement*)root->FirstChild();
   else
@@ -46,6 +45,6 @@
   this->executor = executor.clone();
 
-  if (this->executor)
-    this->executor->setName(paramName);
+  //if (this->executor)
+  //  this->executor->setName(paramName);
 }
 
@@ -60,14 +59,13 @@
   if (likely(this->executor != NULL))
   {
+    std::string loadString = "";
     if (this->loadElem != NULL &&  this->loadElem->ToText())
-      this->loadString = this->loadElem->Value();
-    else
-      this->loadString = NULL;
+      loadString = this->loadElem->Value();
     if (likely(this->object != NULL) &&
-        ( this->loadString != NULL ||
+        ( !loadString.empty() ||
           ((this->executor->getType() & Executor_NoLoadString) == Executor_NoLoadString)))
     {
-      PRINTF(4)("Loading '%s' with Parameters '%s' onto: '%s'(%s)\n", this->paramName, this->loadString, this->object->getName(), this->object->getClassName());
-      this->executor->execute(this->object, this->loadString);
+      PRINTF(4)("Loading value '%s' with Parameters '%s' onto: %s::%s\n", this->paramName.c_str(), loadString.c_str(), this->object->getClassName(), this->object->getName());
+      this->executor->execute(this->object, loadString);
     }
     delete this->executor;
@@ -99,7 +97,7 @@
  * @returns a pointer to itself.
 */
-CLoadParam& CLoadParam::describe(const char* descriptionText)
-{
-  if (LoadClassDescription::parametersDescription && this->paramDesc && !this->paramDesc->getDescription())
+CLoadParam& CLoadParam::describe(const std::string& descriptionText)
+{
+  if (LoadClassDescription::parametersDescription && this->paramDesc && this->paramDesc->getDescription().empty())
   {
     this->paramDesc->setDescription(descriptionText);
@@ -230,15 +228,14 @@
  * @returns the Value of the parameter if found, NULL otherwise
 */
-const char* grabParameter(const TiXmlElement* root, const char* parameterName)
+std::string grabParameter(const TiXmlElement* root, const std::string& parameterName)
 {
   const TiXmlElement* element;
   const TiXmlNode* node;
 
-  if (root == NULL || parameterName == NULL)
-    return NULL;
-  assert( parameterName != NULL);
+  if (root == NULL)
+    return "";
 
   element = root->FirstChildElement( parameterName);
-  if( element == NULL) return NULL;
+  if( element == NULL) return "";
 
   node = element->FirstChild();
@@ -248,5 +245,5 @@
     node = node->NextSibling();
   }
-  return NULL;
+  return "";
 }
 
@@ -256,12 +253,11 @@
  * @returns the Element of the parameter if found, NULL otherwise
  */
-const TiXmlElement* grabParameterElement(const TiXmlElement* root, const char* parameterName)
+const TiXmlElement* grabParameterElement(const TiXmlElement* root, const std::string& parameterName)
 {
   const TiXmlElement* element;
   const TiXmlNode* node;
 
-  if (root == NULL || parameterName == NULL)
+  if (root == NULL)
     return NULL;
-  assert( parameterName != NULL);
 
   element = root->FirstChildElement( parameterName);
Index: trunk/src/lib/util/loading/load_param.h
===================================================================
--- trunk/src/lib/util/loading/load_param.h	(revision 7201)
+++ trunk/src/lib/util/loading/load_param.h	(revision 7221)
@@ -87,12 +87,12 @@
 {
   public:
-    CLoadParam(const TiXmlElement* root, const char* paramName, BaseObject* object, const Executor& executor, bool inLoadCycle = false);
+    CLoadParam(const TiXmlElement* root, const std::string& paramName, BaseObject* object, const Executor& executor, bool inLoadCycle = false);
     virtual ~CLoadParam();
 
-    CLoadParam& describe(const char* descriptionText);
+    CLoadParam& describe(const std::string& descriptionText);
     CLoadParam& defaultValues(const MultiType& value0 = MT_NULL, const MultiType& value1 = MT_NULL,
                               const MultiType& value2 = MT_NULL, const MultiType& value3 = MT_NULL,
                               const MultiType& value4 = MT_NULL);
-    CLoadParam& attribute(const char* attributeName, const Executor& executor);
+    CLoadParam& attribute(const std::string& attributeName, const Executor& executor);
 
 
@@ -101,10 +101,9 @@
     Executor*                executor;
     BaseObject*              object;
-    const char*              paramName;
+    const std::string        paramName;
 
     LoadClassDescription*    classDesc;            //!< The LoadClassDescription of this CLoadParameter
     LoadParamDescription*    paramDesc;            //!< The LoadParameterDescription of this LoadParameter
     const TiXmlElement*      loadElem;             //!< The Element to load.
-    const char*              loadString;           //!< The string loaded by this LoadParam
     const void*              pointerToParam;       //!< A Pointer to a Parameter.
 
@@ -114,6 +113,6 @@
 // helper function
 
-const char* grabParameter(const TiXmlElement* root, const char* parameterName);
-const TiXmlElement* grabParameterElement(const TiXmlElement* root, const char* parameterName);
+std::string grabParameter(const TiXmlElement* root, const std::string& parameterName);
+const TiXmlElement* grabParameterElement(const TiXmlElement* root, const std::string& parameterName);
 
 #endif /* _LOAD_PARAM_H */
